unit listplug; { Contents of file listplug.pas }

interface

uses
  Windows;

const
  lc_copy = 1;
  lc_newparams = 2;
  lc_selectall = 3;
  lc_setpercent = 4;

  lcp_wraptext = 1;
  lcp_fittowindow = 2;
  lcp_ansi = 4;
  lcp_ascii = 8;
  lcp_variable = 12;
  lcp_forceshow = 16;
  lcp_fitlargeronly = 32;
  lcp_center = 64;

  lcs_findfirst = 1;
  lcs_matchcase = 2;
  lcs_wholewords = 4;
  lcs_backwards = 8;

  itm_percent = $FFFE;
  itm_fontstyle = $FFFD;
  itm_wrap = $FFFC;
  itm_fit = $FFFB;
  itm_next = $FFFA;
  itm_center = $FFF9;

  LISTPLUGIN_OK = 0;
  LISTPLUGIN_ERROR = 1;
  
  tcOK = LISTPLUGIN_OK;
  tcError = LISTPLUGIN_ERROR;
  tcStates: array[false..true] of integer = (tcError, tcOk);

type
  tListDefaultParamStruct = record
    size,
    PluginInterfaceVersionLow,
    PluginInterfaceVersionHi: longint;
    DefaultIniName: array[0..MAX_PATH - 1] of char;
  end;
  PListDefaultParamStruct = ^TListDefaultParamStruct;

procedure _strcpy(Dest, Source: PChar; MaxLen: integer);

implementation

procedure _strcpy(Dest, Source: PChar; MaxLen: integer);
begin
  if lstrlen(Source) >= MaxLen then
    begin
      lstrcpyn(Dest, Source, MaxLen);
      Dest[MaxLen] := #0;
    end
  else
    lstrcpy(Dest, Source);
end;

end.
