unit hiListPlug;

{$DEFINE FOCUSFIX}

interface

uses Windows, Messages, KOL, Share, Debug, ListPlug, hiMultiElementEx, hiEditMultiEx, hiListerForm;

const // :|
  tcOK = LISTPLUGIN_OK;
  tcError = LISTPLUGIN_ERROR;
  tcStates: array[false..true] of integer = (tcError, tcOk);

type
  TFileLoadMode = (flmRecreate, flmIgnoreError);

type
  THiListPlug = class(THIMultiElementEx)
  private

  public
    procedure Init;
    function ShowLister(ListerWin, PluginWin: HWND; FileToLoad: PChar; ShowFlags: integer): HWND;
    procedure CloseLister(PluginWin: HWND);
  public
    Control: PControl;
    _prop_DetectString: string; // ???
    _prop_SelectActive: boolean;
    _prop_FileLoadMode: TFileLoadMode;
    _prop_Default: integer;
  end;
  
type
  PPlugInfo = ^TPlugInfo;
  TPlugInfo = record
    Plug: THiListPlug;  // ???
    PlugInst: THiEditMultiEx;
    PlugForm: THiListerForm; 
    PlugLister: HWND;  // QuickView flag fix
  end;

const
  WinCmdClassName: PChar = 'TTOTAL_CMD';

var
  DPS: TListDefaultParamStruct;
  TotalHandle: HWND;
  MultiLister: THiListPlug = nil;

implementation
  
procedure THiListPlug.Init;
begin
  _prop_Mode := 1;
  MultiLister := self;
end;

function THiListPlug.ShowLister;
var
  P: PPlugInfo;
  {$IFDEF FOCUSFIX}
  OldFocus: HWND;
  {$ENDIF}
begin
  {$IFDEF FOCUSFIX}
  OldFocus := 0;
  {$ENDIF}
  if (PluginWin <> 0) then  // ListLoadNext
    P := Pointer(GetProp(PluginWin, ListWinProp))
  else  // ListLoad
    begin
      {$IFDEF FOCUSFIX}
      OldFocus := GetFocus;
      {$ENDIF}
      new(P);
      P.Plug := self;
      P.PlugLister := ListerWin;
      FControl := Pointer(P); // ?!.
      P.PlugInst := AddInstance; 
      FControl := nil;
      P.PlugForm.Control.Style := WS_CHILD or WS_MAXIMIZE and not WS_CAPTION and not WS_BORDER;
    end;
  Applet := nil;  // ???
  if PluginWin <> 0 then P.PlugForm.CloseFile;
  if (P.PlugForm.ReadFile(FileToLoad, ShowFlags, _prop_Default) = tcOK)
  or (_prop_FileLoadMode = flmIgnoreError) then
    begin
      if (PluginWin = 0) then P.PlugForm.SetParentWin(ListerWin);
      if PluginWin = 0 then
        Result := P.PlugForm.Control.Handle
      else
        Result := LISTPLUGIN_OK;
      P.PlugForm.ShowFile;
      {$IFDEF FOCUSFIX}
      if OldFocus <> 0 then SetFocus(OldFocus);
      {$ENDIF}
    end
  else
    if (PluginWin = 0) and (_prop_FileLoadMode = flmRecreate) then
      begin
        CloseLister(P.PlugForm.Control.Handle);
        Result := 0;
      end
    else Result := LISTPLUGIN_ERROR;
end;

procedure THiListPlug.CloseLister;
var
  P: PPlugInfo;
begin
  P := Pointer(GetProp(PluginWin, ListWinProp));
  P.PlugForm.CloseFile;
  _hi_onEvent(P.PlugForm._event_onClose);
  RemoveInstance(P.PlugInst);
  Dispose(P);
end;

end.
