unit hiListerForm;

interface

{$I share.inc}

uses Windows, Messages, KOL, Share, Win, ListPlug, ShellAPI, hiMainForm;

type
 THiPosition = procedure of object;
 THiListerForm = class(THiWin)
   protected
     FResult: integer;
     ListerHandle: HWND;
     QuickView: boolean;
     FileName: string;
     procedure Load;

     procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
     function  _onMessage(var Msg: TMsg; var Rslt: Integer): Boolean; override;
     procedure _onShow(Obj: PObj); override;
     function _OnClose(Sender: PObj; Accept: Boolean): boolean;
     
     procedure _onKeyDown(Sender: PControl; var Key: Longint; Shift: DWORD); override;
     procedure _onKeyUp(Sender: PControl; var Key: Longint; Shift: DWORD); override;
     //procedure _onKeyChar(Sender: PControl; var Key: char; Shift: DWORD); override;
     function isTCKey(const Key: LongInt; const Shift: word): boolean;
   public
     procedure SetParentWin(ParentWin: HWND);
     function ReadFile(const FileToLoad: string; Flags, DefaultReadResult: integer): integer;
     procedure CloseFile;
     procedure ShowFile;
   public
     _event_onLoadFile: THi_Event;
     _event_onCloseFile: THi_Event;
     _event_onSetParent: THi_Event;
     
     _event_onCreate: THi_Event;
     _event_onShow: THi_Event;
     _event_onMove: THi_Event;
     _event_onClose: THi_Event;

     _prop_DragForm: boolean;
     _prop_ClientSize: boolean;
     _prop_ChangeSize: boolean;
     _prop_Position: THiPosition;
     _prop_SkipTCKeys: boolean;
     
     constructor Create(PluginInfo: Pointer);
     destructor Destroy; override;
     
     procedure _work_doResult(var Data: TData; Index: word);
 
     procedure _var_FileName(var Data: TData; Index: word);
     procedure _var_QuickView(var Data: TData; Index: word);
     procedure _var_ListerHandle(var Data: TData; Index: word);
     procedure _var_TotalHandle(var Data: TData; Index: word);
     
     procedure _work_doSkipTCKeys(var _Data: TData; Index: word);
   public
     procedure _work_doFlashWindow(var _Data: TData; Index: word);

     procedure _work_doCaption(var _Data: TData; Index: word);
     procedure _work_doRestore(var _Data: TData; Index: word);
     procedure _work_doMinimize(var _Data: TData; Index: word);
     
     procedure _work_doLeft(var _Data: TData; Index: word);
     procedure _work_doTop(var _Data: TData; Index: word);
     procedure _work_doHeight(var _Data: TData; Index: word);
     procedure _work_doWidth(var _Data: TData; Index: word);
     
     procedure poCenter;
     procedure poDesign;
   end;
   
const
  poNone: THiPosition = nil;
  ListWinProp: PChar = 'hiPlug';
  
  tcOK = LISTPLUGIN_OK;
  tcError = LISTPLUGIN_ERROR;
  
  tcResults: array[false..true] of integer = (tcError, tcOK);

implementation

uses
  hiListPlug;
  
const
  FormCaption = 'Lister plugin. Debug version!..';
  
constructor THiListerForm.Create(PluginInfo: Pointer);
var
  P: PPlugInfo;
begin                    
  inherited Create(nil);
  P := PluginInfo;
  _prop_Visible := false;  // THiWin.Create
  Control := NewForm(nil, FormCaption);
  Applet := Control;
  with Control^ do
    begin
      Font.FontName := 'MS Sans Serif';
      Font.FontHeight := -11;
      onShow := _onShow;
      Border := 0;
      HasBorder := False;
    end;
  SetProp(Control.GetWindowHandle, ListWinProp, DWORD(P));
  P.PlugForm := self;
  ListerHandle := P.PlugLister;
  QuickView := GetParent(P.PlugLister) <> 0;
  InitAdd(Load);
end;

destructor THiListerForm.Destroy;
begin
  RemoveProp(Control.Handle, ListWinProp);
  inherited;
end;

procedure THiListerForm.SetParentWin;
var
  r, rc: TRect;
  DeltaH, DeltaW: integer;
begin
  SetParent(Control.Handle, ParentWin);
  Control.Tabulate; 
  if not QuickView and _prop_ChangeSize then
    begin
      GetWindowRect(ListerHandle, r);
      GetClientRect(ListerHandle, rc);
      if _prop_ClientSize then
        begin
          DeltaW := (r.Right - r.Left) - (rc.Right - rc.Left);
          DeltaH := (r.Bottom - r.Top) - (rc.Bottom - rc.Top);
        end
      else
        begin
          DeltaW := 0;
          DeltaH := 0;          
        end;
      SetWindowPos(ListerHandle, 0, 0, 0, _prop_Width + DeltaW, _prop_Height + DeltaH, SWP_NOMOVE or SWP_NOZORDER);
    end;
  if Assigned(@_prop_Position) then _prop_Position();
  //PostMessage(Control.Handle, WM_SIZE, SIZE_MAXIMIZED, 0);
  _hi_onEvent(_event_onSetParent);
end;

function THiListerForm.ReadFile;
begin
  FileName := FileToLoad;
  FResult := DefaultReadResult;
  _hi_onEvent(_event_onLoadFile, FileToLoad);
  Result := FResult;
end;

procedure THiListerForm.CloseFile;
begin
  _hi_onEvent(_event_onCloseFile);
end;

procedure THiListerForm.ShowFile;
begin
  Control.Show;
end;

procedure THiListerForm._work_doResult;
begin
  FResult := tcResults[ReadBool(Data)];
end;
  
procedure THiListerForm._var_FileName;
begin
  dtString(Data, FileName);
end;

procedure THiListerForm._var_QuickView;
begin
  dtInteger(Data, integer(QuickView));
end;

procedure THiListerForm._var_ListerHandle;
begin
  dtInteger(Data, ListerHandle);
end;

procedure THiListerForm._var_TotalHandle;
begin
  dtInteger(Data, TotalHandle);
end;

procedure THiListerForm._work_doSkipTCKeys;
begin
  _prop_SkipTCKeys := ReadBool(_Data);
end;

// --------------------------------

procedure THiListerForm.Load;
begin
  _hi_onEvent(_event_onCreate);
end;

procedure THiListerForm._onMouseDown;
begin
  if _prop_DragForm then
    begin
      ReleaseCapture;
      Control.Perform(WM_SYSCOMMAND, $F012, 0);
   end;
  inherited;
end;

procedure THiListerForm._onShow;
begin
  _hi_OnEvent(_event_onShow);
  inherited;
end;

function THiListerForm._onClose;
var
  i: integer;
begin
  Result := true;
  if Accept then exit;
  for i := 0 to Control.ChildCount - 1 do
    with Control.Children[i]^ do if isForm then Perform(WM_CLOSE, 0, 1);
  _hi_OnEvent(_event_onClose);
end;

function THiListerForm._onMessage;
begin
   Result := false;
   case Msg.message of
     WM_CLOSE: Result := _onClose(Control, (Msg.lParam = 0));
     WM_MOVE: _hi_OnEvent(_event_onMove);
   end;
   Result := Result or inherited _onMessage(Msg,Rslt);
end;

// --------------------------------

procedure THiListerForm.isTCKey;
begin
  if _prop_SkipTCKeys and (Shift = 0) then
    Result := (Key = VK_ESCAPE) or (Chr(LoWord(Key)) in ['N', 'P', '1'..'7'])
  else
    Result := false;
end;

procedure THiListerForm._onKeyDown;
begin
  if isTCKey(Key, Shift) then
    begin
      if QuickView and (Key = VK_ESCAPE) then Key := VK_TAB;
      PostMessage(ListerHandle, WM_KEYDOWN, Key, 0);
    end
  else inherited;
end;

procedure THiListerForm._onKeyUp;
begin
  if not isTCKey(Key, Shift) then inherited;
end;

// procedure THiListerForm._onKeyChar; begin end;

// --------------------------------

procedure THiListerForm._work_doCaption;
begin
    SetWindowText(ListerHandle, PChar(ToString(_Data)));
end;

procedure THiListerForm._work_doFlashWindow;
begin
  if not QuickView then
    FlashWindow(ListerHandle, true);
end;

procedure THiListerForm._work_doRestore;
begin
  if not QuickView then
    ShowWindow(ListerHandle, SW_SHOWNOACTIVATE);
end;

procedure THiListerForm._work_doMinimize;
begin
  if not QuickView then
    ShowWindow(ListerHandle, SW_SHOWMINNOACTIVE);
end;

procedure THiListerForm._work_doLeft;
var
  t: tagWINDOWPLACEMENT;
begin
  if QuickView then exit;
  t.length := SizeOf(t);
  GetWindowPlacement(ListerHandle, @t);
  SetWindowPos(ListerHandle, 0, ToInteger(_Data), t.rcNormalPosition.Top, 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_NOACTIVATE);
end;

procedure THiListerForm._work_doTop;
var
  t: tagWINDOWPLACEMENT;
begin
  if QuickView then exit;
  t.length := SizeOf(t);
  GetWindowPlacement(ListerHandle, @t);
  SetWindowPos(ListerHandle, 0, t.rcNormalPosition.Left, ToInteger(_Data), 0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_NOACTIVATE);
end;

procedure THiListerForm._work_doWidth;
var 
  r: TRect;
begin
  if QuickView then exit;
  GetWindowRect(ListerHandle, r);
  SetWindowPos(ListerHandle, 0, 0, 0, ToInteger(_Data), r.Bottom - r.Top, SWP_NOMOVE or SWP_NOZORDER);
end;

procedure THiListerForm._work_doHeight;
var 
  r: TRect;
begin
  if QuickView then exit;
  GetWindowRect(ListerHandle, r);
  SetWindowPos(ListerHandle, 0, 0, 0, r.Right - r.Left, ToInteger(_Data), SWP_NOMOVE or SWP_NOZORDER);
end;

procedure THiListerForm.poCenter;
var
  R: TRect;
begin
  if QuickView or (ListerHandle = 0) {Init fix} then exit;
  GetWindowRect(ListerHandle, R);
  SetWindowPos(ListerHandle, 0,
               (ScreenWidth - R.Right + R.Left) div 2,
               (ScreenHeight - R.Bottom + R.Top) div 2,
               0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_NOACTIVATE);
end;

procedure THiListerForm.poDesign;
var
  R: TRect;
begin
  if QuickView or (ListerHandle = 0) then exit; 
  GetWindowRect(ListerHandle, R);
  SetWindowPos(ListerHandle, 0,
               _prop_Left, _prop_Top,
               0, 0, SWP_NOSIZE or SWP_NOZORDER or SWP_NOACTIVATE);
end;


end.
