unit hitcListCommand;

interface

uses Windows, KOL, Share, Debug, ListPlug;

type
  THitcListCommand = class(TDebug)
  private
    FResult: integer;
    FParams: integer;
    Ctrl: PControl;
  public
    _prop_Default: integer;
    _event_onCopy, _event_onSelectAll, _event_onSetPercent, _event_onNewParams: THI_Event;

    constructor Create(Control: PControl); reintroduce;
    destructor Destroy; override;

    procedure _work_doResult(var _Data: TData; Index: word);

    procedure _var_Position(var _Data: TData; Index: word);
    procedure _var_WrapText(var _Data: TData; Index: word);
    procedure _var_Charset(var _Data: TData; Index: word);
    procedure _var_FitImages(var _Data: TData; Index: word);
    procedure _var_FitLargeImagesOnly(var _Data: TData; Index: word);
    procedure _var_CenterImages(var _Data: TData; Index: word);
end;

function ListSendCommand(PluginWin: HWND; Command, Params: integer): integer; stdcall;

exports
  ListSendCommand;

implementation

uses
  hiListerForm;
 
const
  tcProp: PChar = 'TCCOMOBJ';

function ListSendCommand;
begin
  with THitcListCommand(GetProp(PluginWin, tcProp)) do
    begin
      FParams := Params;
      FResult := _prop_Default;
      case Command of
	    lc_copy: _hi_onEvent(_event_onCopy);
        lc_newparams: _hi_onEvent(_event_onNewParams);
        lc_selectall: _hi_onEvent(_event_onSelectAll);
        lc_setpercent: _hi_onEvent(_event_onSetPercent, Params);
      end;
      Result := FResult;
    end;
end;

//---------------------------------------

constructor THitcListCommand.Create;
begin
  inherited Create;
  Ctrl := Control;
  SetProp(Ctrl.Handle, tcProp, cardinal(self));
end;

destructor THitcListCommand.Destroy;
begin
  RemoveProp(Ctrl.Handle, tcProp);
  inherited
end;

procedure THitcListCommand._work_doResult;
begin
  FResult := tcResults[ReadBool(_Data)];
end;

procedure THitcListCommand._var_Position(var _Data: TData; Index: word);
begin
  dtInteger(_Data, FParams);
end;

procedure THitcListCommand._var_WrapText(var _Data: TData; Index: word);
begin
  dtInteger(_Data, integer(lcp_wraptext or FParams = FParams));
end;

procedure THitcListCommand._var_Charset(var _Data: TData; Index: word);
begin
  if lcp_variable or FParams = FParams then
    dtInteger(_Data, 2)
  else if lcp_ansi or FParams = FParams then
    dtInteger(_Data, 0)
  else if lcp_ascii or FParams = FParams then
    dtInteger(_Data, 1)
  else
    dtInteger(_Data, 0);
end;

procedure THitcListCommand._var_FitImages(var _Data: TData; Index: word);
begin
  dtInteger(_Data, integer(lcp_fittowindow or FParams = FParams));
end;

procedure THitcListCommand._var_FitLargeImagesOnly(var _Data: TData; Index: word);
begin
  dtInteger(_Data, integer(lcp_fitlargeronly or FParams = FParams));
end;

procedure THitcListCommand._var_CenterImages(var _Data: TData; Index: word);
begin
  dtInteger(_Data, integer(lcp_center or FParams = FParams));
end;


end.
