unit hitcListPrint;

interface

uses Windows, KOL, Share, Debug;

type
  THitcListPrint = class(TDebug)
  private
    FResult: integer;
    FPrinter: string;
    Ctrl: PControl;
  public
    _prop_Default: integer;
    _event_onPrint: THI_Event;

    constructor Create(Control: PControl); reintroduce;
    destructor Destroy; override;
    
    procedure _work_doResult(var _Data: TData; Index: word);
    procedure _var_DefPrinter(var _Data: TData; Index: word);
end;

function ListPrint(PluginWin: HWND; FileToPrint, DefPrinter: PChar; PrintFlags: integer; var Margins: TRect): integer; stdcall;

exports
  ListPrint;

implementation

uses
  hiListerForm;
 
const
  tcProp: PChar = 'TCPRINTOBJ';

function ListPrint;
begin
  with THitcListPrint(GetProp(PluginWin, tcProp)) do
    begin
      FPrinter := DefPrinter;
      FResult := _prop_Default;
      _hi_onEvent(_event_onPrint, FileToPrint);
      Result := FResult;
    end;
end;

//---------------------------------------

constructor THitcListPrint.Create;
begin
  inherited Create;
  Ctrl := Control;
  SetProp(Ctrl.Handle, tcProp, cardinal(self));
end;

destructor THitcListPrint.Destroy;
begin
  RemoveProp(Ctrl.Handle, tcProp);
  inherited
end;

procedure THitcListPrint._work_doResult;
begin
  FResult := tcResults[ReadBool(_Data)];
end;

procedure THitcListPrint._var_DefPrinter;
begin
  dtString(_Data, FPrinter);
end;


end.
