unit hitcListSearch;

interface

uses Windows, KOL, Share, Debug, ListPlug;

type
  THitcListSearch = class(TDebug)
  private
    FResult, FParams: integer;
    FText: string;
    Ctrl: PControl;
  public
    _prop_Default: integer;
    _event_onSearch: THI_Event;

    constructor Create(Control: PControl); reintroduce;
    destructor Destroy; override;
    
    procedure _work_doResult(var _Data: TData; Index: word);
    procedure _var_SearchString(var _Data: TData; Index: word);
    procedure _var_FindFirst(var _Data: TData; Index: word);
    procedure _var_MatchCase(var _Data: TData; Index: word);
    procedure _var_Backwards(var _Data: TData; Index: word);
    procedure _var_WholeWords(var _Data: TData; Index: word);
end;

function ListSearchText(PluginWin: HWND; SearchString: PChar; Params: integer): integer; stdcall;

exports
  ListSearchText;

implementation

uses
  hiListerForm;
  
const
  tcProp: PChar = 'TCSEARCHOBJ';

function ListSearchText;
begin
  with THitcListSearch(GetProp(PluginWin, tcProp)) do
    begin
      FText := SearchString;
      FParams := Params;
      FResult := _prop_Default;
      _hi_onEvent(_event_onSearch, SearchString);
      Result := FResult;
      FText := '';
      FParams := 0;
    end;
end;

//---------------------------------------

constructor THitcListSearch.Create;
begin
  inherited Create;
  Ctrl := Control;
  SetProp(Ctrl.Handle, tcProp, cardinal(self));
end;

destructor THitcListSearch.Destroy;
begin
  RemoveProp(Ctrl.Handle, tcProp);
  inherited;
end;

procedure THitcListSearch._work_doResult;
begin
  FResult := tcResults[ReadBool(_Data)];
end;

procedure THitcListSearch._var_SearchString;
begin
  dtString(_Data, FText);
end;

type
  TBA = set of byte;
  PBA = ^TBA;

procedure THitcListSearch._var_FindFirst;
begin
  dtInteger(_Data, integer(lcs_findfirst or FParams = FParams));
end;

procedure THitcListSearch._var_MatchCase;
begin
  dtInteger(_Data, integer(lcs_matchcase or FParams = FParams));
end;

procedure THitcListSearch._var_Backwards;
begin
  dtInteger(_Data, integer(lcs_backwards or FParams = FParams));
end;

procedure THitcListSearch._var_WholeWords;
begin
  dtInteger(_Data, integer(lcs_wholewords or FParams = FParams));
end;

end.
