unit hitcListThumb;

interface

uses Windows, KOL, Share, Debug, ListPlug;

type
  THitcListThumb = class(TDebug)
  private
    FResult, FH, FW: integer;
    FN: string;
    bmp: PBitmap;
    procedure ResetSize;
  public
    _prop_Default: integer;
    _prop_Width, _prop_Height: integer;
    _prop_Color: integer;
    
    _event_onGetPreview: THI_Event;
    constructor Create; reintroduce;
    destructor Destroy; override;

    procedure _work_doResult(var _Data: TData; Index: word);
    procedure _work_doClear(var _Data: TData; Index: word);
    procedure _work_doReset(var _Data: TData; Index: word);
    procedure _work_doLoad(var _Data: TData; Index: word);   
    procedure _work_doColor(var _Data: TData; Index: word);

    procedure _var_FileName(var _Data: TData; Index: word);
    procedure _var_Bitmap(var _Data: TData; Index: word);
    procedure _var_Height(var _Data: TData; Index: word);
    procedure _var_Width(var _Data: TData; Index: word);
    procedure _var_HeightTC(var _Data: TData; Index: word);
    procedure _var_WidthTC(var _Data: TData; Index: word);

end;

function ListGetPreviewBitmap(FileToLoad: PChar; Width, Height: integer; ContentBuf: PChar; ContentBufLen: integer): HBITMAP; stdcall;

exports
  ListGetPreviewBitmap;

implementation

uses
  hiListerForm;

var
  Obj: THitcListThumb;

function ListGetPreviewBitmap;
begin
  with Obj do
    begin
      FResult := _prop_Default;
      FN := FileToLoad;
      FH := Height;
      FW := Width;
      ResetSize;
      bmp.Canvas.Brush.Color := _prop_Color;
      bmp.Canvas.FillRect(bmp.BoundsRect);
      _hi_onEvent(_event_onGetPreview, FileToLoad);
      if FResult = LISTPLUGIN_OK then
        Result := bmp.ReleaseHandle
      else
        Result := 0;
      Bmp.Clear;
    end;
end;

//---------------------------------------

constructor THitcListThumb.Create;
begin
  inherited;
  Obj := self;
  bmp := NewBitmap(0, 0);
end;

destructor THitcListThumb.Destroy;
begin
  bmp.Free;
  inherited;
end;

procedure THitcListThumb.ResetSize;
begin
  if _prop_Height = 0 then bmp.Height := FH else bmp.Height := _prop_Height;
  if _prop_Width = 0 then bmp.Width := FW else bmp.Width := _prop_Width;
end;

procedure THitcListThumb._work_doResult;
begin
  FResult := tcResults[ReadBool(_Data)];
end;

procedure THitcListThumb._work_doClear;
begin
  bmp.Clear;
end;

procedure THitcListThumb._work_doReset;
begin
  ResetSize;
end;

procedure THitcListThumb._work_doLoad;
var
  tmp: PBitmap;
begin
  tmp := ToBitmap(_Data);
  if tmp <> nil then bmp.Assign(tmp);
end;

procedure THitcListThumb._work_doColor;
begin
  _prop_Color := ToInteger(_Data);
end;

procedure THitcListThumb._var_FileName;
begin
  dtString(_Data, FN);
end;

procedure THitcListThumb._var_Bitmap;
begin
  dtBitmap(_Data, Bmp);
end;

procedure THitcListThumb._var_Width;
begin
  dtInteger(_Data, Bmp.Width);
end;

procedure THitcListThumb._var_Height;
begin
  dtInteger(_Data, Bmp.Height);
end;

procedure THitcListThumb._var_WidthTC;
begin
  dtInteger(_Data, FW);
end;

procedure THitcListThumb._var_HeightTC;
begin
  dtInteger(_Data, FH);
end;

end.
